#include	"test.h"

int	semid;
pid_t	pid;

void
handler() {
	static int	cnt = 0;
	struct sembuf	sops[1];
	struct timespec	req;

	printf(">> sigalrm handler start\n");

	sops[0].sem_num = 0;
	sops[0].sem_op  = -1;
	sops[0].sem_flg = 0;
	if (semop(semid, sops, 1) < 0) errprint(semop);
#if	0
	req.tv_sec  = 1;
	req.tv_nsec = 0;
	nanosleep(&req, NULL);
#endif
	kill(pid, SIGSTOP);

	sops[0].sem_op = 1;
	if (semop(semid, sops, 1) < 0) errprint(semop);
#if	0
	nanosleep(&req, NULL);
#endif
	kill(pid, SIGCONT);

#if	1
	/*if (++cnt < 2)*/
		kill(getpid(), SIGALRM);
#endif

	printf("<< sigalrm handler end\n");
}

main() {
	struct sched_param	p;
	struct sigaction	act;
	sigset_t		set;
	timer_t			timer_id;
	struct itimerspec	setting;

	printf("> parent process start\n");

	if ((semid = semget(IPC_PRIVATE, 1, 0600)) < 0) errprint(semget);
	if (semctl(semid, 0, SETVAL, 1) < 0) errprint(semctl);

	if (!(pid = fork())) {
		char	arg[11];

		sprintf(arg, "%#x", semid);
		if (execl("test2", "", arg, NULL) < 0) errprint(execl);

		exit(EXIT_FAILURE);
	}

#ifdef	CGE
	p.sched_priority = 58;
	if (sched_setscheduler(0, SCHED_FIFO, &p) < 0) errprint(sched_setscheduler);
#endif

#if	0
	sigaction(SIGALRM, NULL, &act);
	act.sa_handler = handler;
	act.sa_flags   = 0;
	sigaction(SIGALRM, &act, NULL);
	sigemptyset(&set);
	sigaddset(&set, SIGALRM);
	sigprocmask(SIG_UNBLOCK, &set, NULL);

#if	0
#ifdef	CGE
	if (timer_create(CLOCK_REALTIME_HR, NULL, &timer_id) < 0) errprint(timer_create);
#else
	if (timer_create(CLOCK_REALTIME, NULL, &timer_id) < 0) errprint(timer_create);
#endif
	setting.it_interval.tv_sec  = 0;
	setting.it_interval.tv_nsec = 4000000;
	setting.it_value.tv_sec  = 0;
	setting.it_value.tv_nsec = 4000000;
	if (timer_settime(timer_id, 0, &setting, NULL) < 0) errprint(timer_settime);

	for (;;) {
		pause();
	}

	if (timer_delete(timer_id) < 0) errprint(timer_delete);
#else
	kill(getpid(), SIGALRM);
#endif
#else
	for (;;) {
		struct sembuf	sops[1];

		printf(">> parent process start\n");

		sops[0].sem_num = 0;
		sops[0].sem_op  = -1;
		sops[0].sem_flg = 0;
		if (semop(semid, sops, 1) < 0) errprint(semop);
		kill(pid, SIGSTOP);

		sops[0].sem_op = 1;
		if (semop(semid, sops, 1) < 0) errprint(semop);
		kill(pid, SIGCONT);

		printf("<< parent process end\n");
	}
#endif

	wait(NULL);

	if (semctl(semid, 0, IPC_RMID, 0) < 0) errprint(semctl);

	printf("< parent process end\n");

	exit(EXIT_SUCCESS);
}
